// integt.C - Ispitivanje racunanja integrala.

#include "fct.h"
#include "sin.h"
#include "oscil.h"
#include "poli3.h"
#include "log.h"
#include "integ.h"
#include "greska.h"
using namespace Funkcije;

#include <iostream>
#include <new>
using namespace std;

int main () {
  for (bool dalje=true; dalje; ) {
    Fct* fct = 0;
    try {
      cout << "\nFunkcija (S, O, P, L, .)? ";
      char izb; cin >> izb;
      switch (izb) {
        case 's': case 'S': fct = new Sin; break;
        case 'o': case 'O': fct = new Oscil; break;
        case 'p': case 'P': {
          int n; cout << "Red polinoma? "; cin >> n;
          Poli* p = new Poli (n);
          while (true) {
            cout << "Indeks i vrednost nenultog koeficijenta? ";
            int i; double k; cin >> i >> k;
          if (i<0 || k==0) break;
            (*p)[i] = k;
          }
          fct = p;
          break; }
        case 'l': case 'L': fct = new Log; break;
        case '.': dalje = false; break;
        default: throw "Nedozvoljeni izbor";
      }
  if (! dalje) break;
      double a, b; cout << "Interval? "; cin >> a >> b;
      cout << "Integral= " << integral(*fct,a,b) << endl;
    } catch (const Usluge::Greska &g) {
      cout << g;
    } catch (Vekt::Greska g) {
      cout << "\n*** Greska Vektor::" << g << " ***\n\a";
    } catch (const char *g) {
      cout << "\n*** " << g << " ***\n\a";
    } catch (bad_alloc) {
      cout << "\n*** Dodela memorije nije uspela ***\n\a";
    }
    delete fct;
  }
}
