// log.h - Klasa za funkciju logaritam (Log).

#ifndef _log_h_
#define _log_h_

#include "fct.h"
#include <cmath>
using namespace std;
#include "greska.h"
using Usluge::Greska;

namespace Funkcije {
  class GNemaLogaritam: public Greska {
    double x;
  public:
    GNemaLogaritam (): Greska ("Logaritam negativnog broja") {}
    GNemaLogaritam (double x): Greska () { this->x = x; }
  private:
    void pisi (ostream &d) const {
      if (imaPoruke ()) Greska::pisi(d);
      else d << "\n*** Ne postoji logaritam od " << x << " ***\a\n";
    }
  };

  class Log: public Fct {
  public:
    double operator() (double x) const {
      if (x <= 0) throw GNemaLogaritam (x);
      return log (x);
    }
  };
} // namespace

#endif
