// niz1.h - Definicije klase nizova podataka (Niz).

#include "podatak.h"

class Niz: public Podatak {
  Podatak** niz; int kap;
  void kopiraj (const Niz& nn);
  void brisi () { ~*this; delete [] niz; }
public:
  Niz (double kk=10);
  Niz (const Niz& nn) { kopiraj (nn); }
  ~Niz () { brisi (); }
  Podatak* kopija () const { return new Niz (*this); }
  Niz& operator= (const Niz& nn) {
    if (this != &nn) { brisi (); kopiraj (nn); }
    return *this;
  }
  int operator+ () const { return kap; }
  Podatak& operator[] (int ind) {
    if (ind < 0 || ind >= kap) throw 1;
    if (niz[ind] == 0) throw 2;
    return *niz[ind];
  }
  const Podatak& operator[] (int ind) const
    { return const_cast<Niz&>(*this)[ind]; }
  Niz& operator+= (const Podatak& pp);
  Niz& operator-= (int ind) {
    if (ind < 0 || ind >= kap) throw 1;
    delete niz[ind]; niz[ind] = 0;
    return *this;
  }
  void operator~ ();
private:
  void pisi  (ostream& dd) const;
};
