// red2.C - Definicije metoda uz klasu Red.

#include "red2.h"

void Red::kopiraj (const Red& r) {   // Kopiranje reda.
  prvi = posl = 0; duz = r.duz;
  for (Elem* tek=r.prvi; tek; tek=tek->nar)
    posl = (posl ? posl->nar : prvi) = new  Elem (tek->pod);
}

void Red::brisi () {                 // Brisanje svih elemenata reda.
  while (prvi) { Elem* stari=prvi; prvi = prvi->nar; delete stari; }
  posl = 0; duz = 0;
}

Red& Red::operator+= (const Red& r) {     // Dodavanje reda.
  if (+r) {
    Red s (r);
    (posl ? posl->nar : prvi) = s.prvi;
    posl = s.posl; duz += s.duz;
    s.prvi = s.posl = 0; s.duz = 0;
  }
  return *this;
}

Red Red::operator+ (const Red& r) const    // Spoj dva reda.
  // Ne moze "inline" zbog vracanja kopije lokalnog objekta!
  { Red s (*this); s += r; return s; }

int Red::operator-- () {           // Brisanje prvog elementa iz reda.
  if (duz) {
    int pod = prvi->pod;
    Elem* stari = prvi; prvi = prvi->nar; delete stari;
    if (! prvi) posl = 0;
    duz--;
    return pod;
  } else return 0;
}

Red Red::operator- (int k) const { // Red bez elemenata jednakih k.
  Red r;
  for (Elem* tek=prvi; tek; tek=tek->nar) if (tek->pod != k) r+=tek->pod;
  return r;
}
