// red2.h - Definicija klase redova za cekanje (Red).

class Red {
  struct Elem {                          // Elementi reda za cekanje:
    int   pod;                           //   sadrzaj elementa,
    Elem* nar;                           //   naredni element;
    Elem (int p, Elem* n=0)              //   konstruktor.
      { pod = p; nar = n; }
  } ;
  Elem *prvi, *posl;                     // Pocetak i kraj reda.
  int   duz;                             // Duzina reda za cekanje.
  void  kopiraj (const Red& r);          // Kopiranje reda.
  void  brisi ();                        // Brisanje svih elemenata.
public:
  Red () { prvi = posl = 0; duz = 0; }   // Konstruktor praznog reda.
  Red (int a)                            // Konverzija int u Red.
    { prvi = posl = new Elem (a); duz = 1; }
  Red (const Red& r) { kopiraj (r); }    // Konstruktor kopije.
  ~Red () { brisi (); }                  // Destruktor.
  int operator+ () const { return duz; } // Duzina reda za cekanje.
  Red& operator=  (const Red& r) {       // Dodela vrednosti.
    if (this != &r) { brisi (); kopiraj (r); }
    return *this;
  }
  Red& operator+= (const Red& r) ;       // Dodavanje reda.
  Red operator+  (const Red& r) const ;  // Spoj dva reda.
  int operator-  () const                // Prvi element.
    { return duz ? prvi->pod : 0; }
  int operator-- () ;                    // Brisanje prvog elementa.
  Red operator-  (int k) const ;         // Red bez elemenata jednakih k.
  Red& operator-= (int k)          // Brisanje svih elemenata jednakih k.
    { return *this = *this - k; }
  Red& operator~  ()               // Brisanje svih elemenata.
    { brisi (); return *this; }
} ;
