// tekst3.h - Defincija klase za obradu znakovnih nizova (Tekst).

#include <iostream.h>
#include <string.h>

class Tekst {
  char* niz;                          // Pokazivac na sam tekst.
  void kopiraj(const char* );         // Kopiranje teksta
public:                               // Inicijalizacija:
  Tekst () { niz = 0; }               //   - kao prazan niz
  Tekst (const char* n)               //   - nizom znakova
    { kopiraj (n) ; }
  Tekst (const Tekst& t)              //   - tipom Tekst
    { kopiraj (t.niz) ; }
  ~Tekst () { delete [] niz; }        // Unistavanje.
  int operator+ () const              // Duzina teksta.
    { return strlen (niz); }
  Tekst& operator= (const Tekst&);    // Dodela vrednosti.
  friend Tekst operator+              // Spajanje tekstova.
    (const Tekst&, const Tekst&);
  Tekst& operator+= (const Tekst& t)  // Dodavanje teksta.
    { return *this = *this + t; }
  char& operator[] (int);             // Znak u tekstu.
  const char& operator[] (int) const;
  Tekst operator() (int, int) const;  // Podniz teksta.
  friend int operator% (const Tekst&, const Tekst&);     // Mesto podniza.
  friend ostream& operator<< (ostream& d,const Tekst& t) // Pisanje teksta.
    { return d << t.niz; }
  friend istream& operator>> (istream&, Tekst&);         // Citanje teksta.
} ;