// tekst4.h - Definicija klase znakovnih nizova (Tekst).

#include "objekat.h"
#include <cstring>
using namespace std;

class Tekst: public Obj {
  char* tks;                                      // Sadrzaj objekta.
  bool jednako (const Obj &obj) const             // Da li su jednaki?
    { return strcmp (tks, ((Tekst&)obj).tks) == 0; }
  void pisi  (ostream& d) const                   // Pisanje.
    { d << '[' << (tks ? tks : "") << ']'; }
  void citaj (istream& d) ;                       // Citanje.
  void kopiraj (const char* niz);                 // Kopiranje.
public:
  Tekst (const char *niz="") { kopiraj (niz); }   // Inicijalizacija nizom.
  Tekst (const Tekst &tt): Obj (*this)            // Inicijalizacija tekstom.
    { kopiraj (tt.tks); }
  ~Tekst () { delete [] tks; }                    // Unistavanje.
  Tekst& operator= (const Tekst& t) {             // Dodela vrednosti.
    if (this != &t) {
      Obj::operator= (t);
      delete [] tks; kopiraj (t.tks);
    }
    return *this;
  }
  Tekst* kopija () const { return new Tekst (*this); } // Kopija objekta.
};
