// vreme.h - Definicija klase vremenskih intervala (Vreme).

#include <iostream.h>

class Vreme {
  long t;                                        // Vreme u sekundama.
public:
  Vreme (int h, int m, int s)                    // Sastavljanje vremena.
    { t = ((h * 60L + m) * 60 + s); }
  Vreme (long s=0) { t = s; }                       // Sekunde u vreme.
  friend int  sat (Vreme v) { return v.t / 3600; }  // Sati u vremenu.
  friend int  min (Vreme v) { return (v.t/60)%60; } // Minute u vremenu.
  friend int  sek (Vreme v) { return v.t % 60; }    // Sekunde u vremenu.
  friend long Sek (Vreme v) { return v.t; }         // Vreme u sekunde.
  Vreme   operator+  ()    { return  *this; }                   // +t
  Vreme   operator-  ()    { return Vreme (-t); }               // -t
  Vreme & operator++ ()    { ++t; return *this; }               // ++t
  Vreme   operator++ (int) { Vreme w (*this); t++; return w; }  // t++
  Vreme & operator-- ()    { --t; return *this; }               // --t
  Vreme   operator-- (int) { Vreme w (*this); t--; return w; }  // t--
  friend Vreme operator+ (const Vreme &v, const Vreme &w)       // v +  w
    { return Vreme (v.t + w.t); }
  friend Vreme operator- (const Vreme &v, const Vreme &w)       // v -  w
    { return Vreme (v.t - w.t); }
  friend Vreme operator* (const Vreme &v, int k)                // v *  k
    { return Vreme (v.t * k); }
  friend Vreme operator/ (const Vreme &v, int k)                // v /  k
    { return Vreme (v.t / k); }
  typedef const Vreme &CVreU;
  Vreme & operator+= (CVreU v) { t += v.t; return *this; }      // t += v
  Vreme & operator-= (CVreU v) { t -= v.t; return *this; }      // t -= v
  Vreme & operator*= (int   k) { t *= k;   return *this; }      // t *= k
  Vreme & operator/= (int   k) { t /= k;   return *this; }      // t /= k
  friend bool operator< (CVreU v, CVreU w) { return v.t< w.t; } // v <  w
  friend bool operator<=(CVreU v, CVreU w) { return v.t<=w.t; } // v <= w
  friend bool operator> (CVreU v, CVreU w) { return v.t> w.t; } // v >  w
  friend bool operator>=(CVreU v, CVreU w) { return v.t>=w.t; } // v >= w
  friend bool operator==(CVreU v, CVreU w) { return v.t==w.t; } // v == w
  friend bool operator!=(CVreU v, CVreU w) { return v.t!=w.t; } // v != w
  friend istream & operator>>(istream &d, Vreme &v)       // Citanje.
    { int h, m, s; d >> h >> m >> s; v = Vreme (h, m, s); return d; }
  friend ostream & operator<<(ostream &d, CVreU v) {      // Ispisivanje.
    Vreme w (v); if (w.t < 0) { d << '-'; w = - w; }
    return d << sat (w) << ':' << min (w) << ':' << sek (w);
  }
};
